#ifndef _CONFIG_H_
#define _CONFIG_H_

#include <stdint.h>
#include <spi.h>


#define CONFIG_MAGIC 0xdead0000

typedef struct __attribute__((__packed__)) s_configBlock {
    uint32_t configMagic;
    char deviceName[16];
    uint8_t macAddress[6];
    int32_t frontendThreshold;
    char brokerName[64];
    char watchdogTopic[64];
    char startupTopic[64];
    char statusTopic[64];
    char mbusDataTopic[64];
    char syslogServerName[64];
    uint8_t filler[2];
} t_configBlock;

void configInit();
t_configBlock* getConfig();

#endif /* _CONFIG_H_ */
